#include "math.h"
#include "runlength.h"

/*
  A posio dos pixels :
  |1|2|
  |4|3|
*/

/*unsigned char ver_quatro [2][2][2][2] =
 {{{{{0},{0}},{{0},{1}}},{{{0},{1}},{{1},{1}}}},{{{{0},{1}},{{1},{1}}},{{{1},{1}},{{1},{1}}}}};

 /*void AumentarResolucao(IMAGEM *imagem){
	 int w, h, x, y, temp;

	 w = imagem->width;
	 h = imagem->height;

	 for(y = 0; y < h; y++){
		 for(x = 0; x < w; x++){
			 temp = imagem->rotacionado[y][x];
			 imagem->rotacionado[y][x] = BRANCO;
			 //marca o 1
			 imagem->pixels[y*2][x*2] = temp;
			 //marca o 2
			 imagem->pixels[y*2][(x*2)+1] = temp;
			 //marcar o 3
			 imagem->pixels[(y*2)+1][(x*2)+1] = temp;
			 //marcar o 4
			 imagem->pixels[(y*2)+1][x*2] = temp;
		 }
 	}

 	imagem->width = imagem->width *2;
 	imagem->height = imagem->height*2;
 }*/

/*
#define rotacionar_classico_ponto(p, r){										\
	r.x = (int)round((p.x - w / 2) * cosseno - (p.y - h / 2) * seno + w / 2);	\
	r.y = (int)round((p.y - h / 2) * cosseno + (p.x - w / 2) * seno + h / 2);	\
}

void
RotacionarClassicoAntigo(IMAGEM *imagem, double angulo)
{
	register int w, h, esquerda, direita, superior, inferior, novo_width, novo_height, x, y;
	PONTO ponto_esquerdo_rotacionado, ponto_direito_rotacionado, ponto_superior_rotacionado, ponto_inferior_rotacionado,
	      ponto_esquerdo_original, ponto_direito_original, ponto_superior_original, ponto_inferior_original, ponto, p;
	double angulo_total, cosseno, seno;

	w = imagem->width;
	h = imagem->height;

	angulo_total = DEG2RAD(-angulo);
	cosseno = cos(angulo_total);
	seno = sin(angulo_total);

	ponto_esquerdo_original.x = 0;
	ponto_esquerdo_original.y = 0;

	ponto_direito_original.x = w-1;
	ponto_direito_original.y = 0;

	ponto_superior_original.x = 0;
	ponto_superior_original.y = h-1;

	ponto_inferior_original.x = w-1;
	ponto_inferior_original.y = h-1;

	rotacionar_classico_ponto(ponto_esquerdo_original, ponto_esquerdo_rotacionado);
	rotacionar_classico_ponto(ponto_direito_original , ponto_direito_rotacionado );
	rotacionar_classico_ponto(ponto_superior_original, ponto_superior_rotacionado);
	rotacionar_classico_ponto(ponto_inferior_original, ponto_inferior_rotacionado);

	#define MIN(a,b,c,d) min(min(min(a,b),c),d);

	#define MAX(a,b,c,d) max(max(max(a,b),c),d);


	esquerda = MIN(ponto_esquerdo_rotacionado.x,
				   ponto_direito_rotacionado.x,
				   ponto_superior_rotacionado.x,
				   ponto_inferior_rotacionado.x);

	direita = MAX(ponto_esquerdo_rotacionado.x,
				  ponto_direito_rotacionado.x,
				  ponto_superior_rotacionado.x,
				  ponto_inferior_rotacionado.x);

	superior = MIN(ponto_esquerdo_rotacionado.y,
				   ponto_direito_rotacionado.y,
				   ponto_superior_rotacionado.y,
				   ponto_inferior_rotacionado.y);

	inferior = MAX(ponto_esquerdo_rotacionado.y,
	 			   ponto_direito_rotacionado.y,
				   ponto_superior_rotacionado.y,
                   ponto_inferior_rotacionado.y);

	novo_width  = direita  - esquerda + 1;
	novo_height = inferior - superior + 1;
	imagem->width  = novo_width;
	imagem->height = novo_height;
	for (y = 0; y < h; y++){
		for (x = 0; x < w; x++){
			//printf("-(%d,%d)-", x, y);
			if (imagem->pixels[y][x] == PRETO)
		  	{
				ponto.x = x;
				ponto.y = y;
				rotacionar_classico_ponto(ponto, p);
				p.x -= esquerda;
				p.y -= superior;
				imagem->rotacionado[p.y][p.x] = PRETO;
			}
		}
		//printf("\n");
	}
}*/

/*void DiminuirResolucao(IMAGEM *imagem){
	register int i, j, x, y, novo_height, novo_width, w, h;

	novo_height = imagem->height;
	novo_width = imagem->width;

	j = 0;
	i = 0;

	w = novo_width/2 + novo_width%2;
	h = novo_height/2 + novo_height%2;

	imagem->rotacionado = calloc(h, sizeof(unsigned char *));
	for(y = 0; y < novo_height; y++){
	      imagem->rotacionado[y] = calloc(w, sizeof(unsigned char *));
        }

	#define VER_4(xx, yy){																																							\
		if(xx+1 < novo_width && yy+1 < novo_height){																																\
			if(ver_quatro[imagem->pixels[yy][xx]][imagem->pixels[yy][(xx+1)]][imagem->pixels[(yy+1)][(xx+1)]][imagem->pixels[(yy+1)][xx]]){	\
				imagem->rotacionado[j][i] = PRETO;																																	\
			}																																										\
		}																																											\
		else{																																										\
			if(ver_quatro[imagem->pixels[yy][xx]][0][0][1]){																												\
				imagem->rotacionado[j][i] = PRETO;																																	\
			}																																										\
		}																																											\
	}

	for(y = 0; y < novo_height; y = y + 2){
		for(x = 0; x < novo_width; x = x + 2){
			VER_4(x, y);
			if(i < w-1){
				i++;
			}
		}
		if(x-1 > 0 && y+1 < novo_height){
			i++;
			if(imagem->pixels[y][(x-1)] == PRETO && imagem->pixels[(y+1)][(x-1)] == PRETO){
				imagem->rotacionado[j][i] = PRETO;
			}
		}
		j++;
		i = 0;
	}
	/*if(y-1 > 0 && x+1 < novo_width){
		for(x = 0; x < novo_width; x = x + 2){
			if(imagem->pixels[(y-1)][x] == PRETO && imagem->pixels[(y-1)][(x+1)] == PRETO){
				imagem->rotacionado[j][i] = PRETO;
				i++;
			}
		}
	}*/
	/*imagem->width  = w;
	imagem->height = h;
}         */

void DiminuirResolucao(IMAGEM *imagem){
     register int w, h, nw, nh, x, y, temp;

     w = imagem->width;
     h = imagem->height;

     nw = w/2 + w%2;
     nh = h/2 + h%2;
     
     temp = 0;

     imagem->rotacionado = calloc(nh, sizeof(unsigned char *));
     for(y = 0; y < nh; y++){
           imagem->rotacionado[y] = calloc(nw, sizeof(unsigned char));
     }

     for(y = 0; y < h; y = y + 2){
        for(x = 0; x < w; x = x + 2){
           temp = 0;
           if(imagem->pixels[y][x] == PRETO){
             temp++;
           }
           if(x+1 < w && imagem->pixels[y][x+1] == PRETO){
             temp++;
           }
           if(y+1 < h && imagem->pixels[y+1][x] == PRETO){
             temp++;
           }
           if(y+1 < h && x+1 < w && imagem->pixels[y+1][x+1] == PRETO){
             temp++;
           }
           if(temp > 1){
             imagem->rotacionado[y/2][x/2] = PRETO;
           }
        }
     }
     
     imagem->width = nw;
     imagem->height = nh;
}

void RotacionarMaior(IMAGEM *imagem, double angulo){

	//AumentarResolucao(imagem);
	//RotacionarClassicoAntigo(imagem, angulo);
	DiminuirResolucao(imagem);
}
