#include "math.h"
#include "runlength.h"

void EncontrarLimites(IMAGEM *imagem){
	register int x, y, w, h, y_sup, y_inf, x_esq, x_dir, sair, i, j;

	w = imagem->width;
	h = imagem->height;

	sair = 0;
	for(y = 0; !sair && y < h; y++){
		for(x = 0; !sair && x < w; x++){
			if(imagem->pixels[y][x] == PRETO){
				y_sup = y;
				sair = 1;
			}
		}
	}

	sair = 0;
	for(x = 0; !sair && x < w; x++){
		for(y = 0; !sair && y < h; y++){
			if(imagem->pixels[y][x] == PRETO){
				x_esq = x;
				sair = 1;
			}
		}
	}

	sair = 0;
	for(y = h-1; !sair && y >= 0; y--){
		for(x = w-1; !sair && x >= 0; x--){
			if(imagem->pixels[y][x] == PRETO){
				y_inf = y;
				sair = 1;
			}
		}
	}

	sair = 0;
	for(x = w-1; !sair && x >= 0; x--){
		for(y = h-1; !sair && y >= 0; y--){
			if(imagem->pixels[y][x] == PRETO){
				x_dir = x;
				sair = 1;
			}
		}
	}

	imagem->rotacionado = calloc((y_inf-y_sup+3), sizeof(unsigned char *));
	imagem->rotacionado[0] = calloc((x_dir-x_esq+3), sizeof(unsigned char));

	for(y = y_sup, j = 1; y <= y_inf; y++, j++){
		imagem->rotacionado[j] = calloc((x_dir-x_esq+3), sizeof(unsigned char));
		for(i = 1, x = x_esq; x <= x_dir; x++, i++){
			imagem->rotacionado[j][i] = imagem->pixels[y][x];
		}
	}

	imagem->rotacionado[j] = calloc((x_dir-x_esq+3), sizeof(unsigned char));

	imagem->width = i+1;
	imagem->height = j+1;
}
