#include "runlength.h"
#include <time.h>


void main(int argc, char * argv[])
{
	LPSTR lpSrc, lpDst1, lpDst, lpSrcOrig, lpSrcRota, lpDst2, lpDst3, lpDst4;
	IMAGEM *src, *src1;
	int t1, t2, angulo;//, y_sup, y_inf, x_esq, x_dir;

	lpSrc = (LPSTR)malloc(100);
	lpSrcOrig = (LPSTR)malloc(100);
	lpSrcRota = (LPSTR)malloc(100);
	lpDst = (LPSTR)malloc(100);
	lpDst1 = (LPSTR)malloc(100);
	lpDst2 = (LPSTR)malloc(100);
	lpDst3 = (LPSTR)malloc(100);
	lpDst4 = (LPSTR)malloc(100);

	sprintf(lpSrc, "%s.tif", argv[1]);
	angulo = atoi(argv[2]);

	sprintf(lpSrcOrig, "%s.tif", argv[1], angulo);
	sprintf(lpSrcRota, "%s.tif", argv[3], angulo);

    sprintf(lpDst, "%s_F_%2d.tif", argv[1],angulo);

    sprintf(lpDst1, "%s_P_%2d.tif", argv[1],angulo);

    sprintf(lpDst2, "%s_L.tif", argv[1]);

    sprintf(lpDst3, "%s_C_%2d.tif", argv[1],angulo);

    sprintf(lpDst4, "%s_CF_%2d.tif", argv[1],angulo);


/*	t1 = clock();
	src = Abrir2(lpSrc);
    FastRotationRunBlack(src, (double)angulo);
    t2 = clock();
	fprintf(stderr, "tempo do FastRotationRunBlack = %5d\n", t2-t1);
    Salvar(src, lpDst);
    Fechar(src, 1);*/

/*	t1 = clock();
	src1 = Abrir(lpSrc, (double)angulo);
    RotacionarMaior(src1, (double)angulo);
    t2 = clock();
	fprintf(stderr, "tempo do Algoritmo Proposto = %5d\n", t2-t1);
    Salvar(src1, lpDst1);
    Fechar(src1, 1);*/

    /*t1 = clock();
	src1 = Abrir2(lpSrc);
	RotacionarClassico(src1, (double)angulo);
	t2 = clock();
	fprintf(stderr, "tempo do Rotacionar Classico = %5d\n", t2-t1);
	Salvar(src1, lpDst3);
    Fechar(src1, 1);*/

    t1 = clock();
    src1 = Abrir2(lpSrc);
    RotacionarFiltro(src1, (double)angulo);
    t2 = clock();
    fprintf(stderr, "tempo do Rotacionar Classico com Filtro = %5d\n", t2-t1);
    Salvar(src1, lpDst4);
    Fechar(src1,1);


/*	src = Abrir2(lpSrcOrig);
 	src1 = Abrir2(lpSrcRota);
 	t1 = clock();
    PSNR_Analysis(src, src1);
    t2 = clock();
	fprintf(stderr, "tempo do PSNR = %5d\n", t2-t1);
    Fechar(src1, 1);
    Fechar(src, 1);*/

    /*src = Abrir2(lpSrc);
    EncontrarLimites(src);
    Salvar(src, lpDst2);
    Fechar(src, 1);*/

}
